/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͑eʋLƂǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "storage_task.h"
#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"
#include "modules/scsi_decoder/scsi_decoder.h"
#include "modules/control_access/ctrl_access.h"

//_____ 錾 _______________________________________________________________

bit ms_data_direction;
static _MEM_TYPE_SLOW_ U8  dCBWTag[4];

extern _MEM_TYPE_SLOW_ U8  g_scsi_status;
extern _MEM_TYPE_FAST_ U32 g_scsi_data_remaining;
extern bit ms_multiple_drive;
extern _MEM_TYPE_SLOW_ U8  g_scsi_command[16];

extern U8 endpoint_status[MAX_EP_NB];

_MEM_TYPE_SLOW_ U8 usb_LUN;

void usb_mass_storage_cbw (void);
void usb_mass_storage_csw (void);

//!
//! @brief ̊֐͋LƂɕKvƂʰ޳/ĳ̎܂B
//!
//! @param Ȃ
//!
//! @return Ȃ
//!
//!/
void storage_task_init (void)
{
	Leds_init();
	Usb_enable_sof_interrupt();
	df_mem_init();							// DataFlashײނɕKvƂʰ޳/ĳ̎
}

//! @brief eʋLƊǗ̓_
//!
//! ̊֐͑eʋLSCSI߂USB޽q܂B
//!
//! @param Ȃ
//!
//! @return Ȃ
void storage_task (void)
{
	if (Is_device_enumerated())
	{
		Usb_select_endpoint(EP_MS_OUT);
		if (Is_usb_receive_out())
		{
			usb_mass_storage_cbw();
			usb_mass_storage_csw();
		}
	}
}

//! @brief USB߉(CBW)Ǘ
//!
//! ̊֐CBW߂𕜍SCSI߂i[܂B
//!
//! @warning Code:??޲ (֐ޒ)
//!
//! @param Ȃ
//!
//! @return Ȃ
void usb_mass_storage_cbw (void)
{
	bit cbw_error;
	U8  c;
	U8  dummy;

	cbw_error = FALSE;
	Usb_select_endpoint(EP_MS_OUT);			//! dCBWSignature
	if (0x55 != Usb_read_byte())
		{ cbw_error = TRUE; }				//! 'U'
	if (0x53 != Usb_read_byte())
		{ cbw_error = TRUE; }				//! 'S'
	if (0x42 != Usb_read_byte())
		{ cbw_error = TRUE; }				//! 'B'
	if (0x43 != Usb_read_byte())
		{ cbw_error = TRUE; }				//! 'C'
	if (cbw_error)
	{
		Usb_ack_receive_out();
		Usb_select_endpoint(EP_MS_IN);
		Usb_enable_stall_handshake();
		endpoint_status[(EP_MS_IN & MSK_EP_DIR)] = 0x01;
		return;
	}

	dCBWTag[0] = Usb_read_byte();			//! CSWŌJԂׂCBWނi[
	dCBWTag[1] = Usb_read_byte();
	dCBWTag[2] = Usb_read_byte();
	dCBWTag[3] = Usb_read_byte();

	LSB0(g_scsi_data_remaining) = Usb_read_byte();
	LSB1(g_scsi_data_remaining) = Usb_read_byte();
	LSB2(g_scsi_data_remaining) = Usb_read_byte();
	LSB3(g_scsi_data_remaining) = Usb_read_byte();

	if (Usb_read_byte() != 0x00)			//! bmCBWFlags.bit7=1ȂΕ=IN
	{
		Usb_set_ms_data_direction_in();
	}
	else
	{
		Usb_set_ms_data_direction_out();
	}

	usb_LUN = Usb_read_byte();

	if (!ms_multiple_drive)
	{
		usb_LUN = get_cur_lun();
	}

	dummy = Usb_read_byte();				// UCBWCBLengthǂݍ


	for (c=0; c<16; c++)					// scsi_commandi[
	{
		g_scsi_command[c] = Usb_read_byte();
	}
	Usb_ack_receive_out();

	if (Is_usb_ms_data_direction_in())
	{
		Usb_select_endpoint(EP_MS_IN);
	}

	if (TRUE != scsi_decode_command())
	{
		U8 ep;
		Usb_enable_stall_handshake();
		if (Is_usb_ms_data_direction_in())
		{
			ep = (EP_MS_IN & MSK_EP_DIR);
		}else{
			ep = (EP_MS_OUT & MSK_EP_DIR);
		}
		endpoint_status[ep] = 0x01;
	}
}

//! @brief USBߏԕ(CSW)Ǘ
//!
//! ̊֐͍ŌCBWł̊֘AɉԂ𑗂܂B
//!
//! @param Ȃ
//!
//! @return Ȃ
void usb_mass_storage_csw (void)
{
	Usb_select_endpoint(EP_MS_IN);
	while (Is_usb_endpoint_stall_requested())
	{
		Usb_select_endpoint(EP_CONTROL);
		if (Is_usb_receive_setup()) { usb_process_request(); }
		Usb_select_endpoint(EP_MS_IN);
	}

	Usb_select_endpoint(EP_MS_OUT);
	while (Is_usb_endpoint_stall_requested())
	{
		Usb_select_endpoint(EP_CONTROL);
		if (Is_usb_receive_setup()) { usb_process_request(); }
		Usb_select_endpoint(EP_MS_OUT);
	}

	Usb_select_endpoint(EP_MS_IN);
	while(!Is_usb_write_enabled())
	{
		if(!Is_usb_endpoint_enabled()) return;	// USBؾ
	}
											//! CSW[
	Usb_write_byte(0x55);					//! 'U'
	Usb_write_byte(0x53);					//! 'S'
	Usb_write_byte(0x42);					//! 'B'
	Usb_write_byte(0x53);					//! 'S'
											//! i[CBWޏ
	Usb_write_byte(dCBWTag[0]);
	Usb_write_byte(dCBWTag[1]);
	Usb_write_byte(dCBWTag[2]);
	Usb_write_byte(dCBWTag[3]);
											//! ްc]l
	Usb_write_byte( LSB0(g_scsi_data_remaining) );
	Usb_write_byte( LSB1(g_scsi_data_remaining) );
	Usb_write_byte( LSB2(g_scsi_data_remaining) );
	Usb_write_byte( LSB3(g_scsi_data_remaining) );

	//! ߏԏ
	Usb_write_byte(g_scsi_status);			//! 0:ʉ߁A1:s

	Usb_send_in();
}
