/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBνĕWHIDƉpǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "host_hid_task.h"
#include "modules/usb/host_chap9/usb_host_task.h"
#include "modules/usb/host_chap9/usb_host_enum.h"
#include "lib_mcu/usb/usb_drv.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

#ifndef LOG_STR_CODE
#define LOG_STR_CODE(str)
#else
U8 code log_enter_boot[]="Entering bootloader";
U8 code log_hid_connect[]="Generic HID connected";
#endif

//_____ 錾 _______________________________________________________________

U8 hid_connected;
#if( HID_GENERIC_DEMO_FULL == ENABLE )
S8 hid_temperature=0;
U8 hid_potentiometer=0;
#endif
U8 hid_enter_dfu;
static U8 pipe_hid_in;
static U8 pipe_hid_out;

//!@brief ̊֐νĕWHIDp܂B
//!
//!@param	Ȃ
//!
//!@return	Ȃ
void host_hid_task_init (void)
{
	hid_enter_dfu=0;
	hid_connected=0;
}

//! @brief ̊֐νĕWHIDpǗ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void host_hid_task (void)
{
	U8 i;
	U8 buf_hid[8];

	// HIDuڑ
	if(Is_host_ready())
	{
		if(Is_new_device_connection_event())	// uڑ
		{
			hid_connected=0;
			hid_enter_dfu=0;
			for(i=0;i<Get_nb_supported_interface();i++)
			{
				if(Get_class(i)==HID_CLASS && Get_subclass(i)==NO_SUBCLASS && Get_protocol(i)==NO_PROTOCOL)
				{
					LOG_STR_CODE(log_hid_connect);
					hid_connected=1;
					if(Is_ep_addr_in(Get_ep_addr(i,0)))
					{
						PIPE_HID_IN=host_get_hwd_pipe_nb(Get_ep_addr(i,0));
						PIPE_HID_OUT=host_get_hwd_pipe_nb(Get_ep_addr(i,1));
					}
					else
					{
						PIPE_HID_IN=host_get_hwd_pipe_nb(Get_ep_addr(i,1));
						PIPE_HID_OUT=host_get_hwd_pipe_nb(Get_ep_addr(i,0));
					}
					Host_select_pipe(PIPE_HID_IN);
					Host_continuous_in_mode();
					Host_unfreeze_pipe();
					break;
				}
			}
		}
		if(hid_connected)
		{
			Host_select_pipe(PIPE_HID_IN);
			if(Is_host_in_received())
			{
				if(Is_host_stall()==FALSE)
				{
#if( HID_GENERIC_DEMO_FULL == ENABLE )
					i=Usb_read_byte();					// LED
					i=Usb_read_byte();					// ޮè
					hid_potentiometer=Usb_read_byte();	// ϒR
					hid_temperature=Usb_read_byte();	// x
#else
					i=Usb_read_byte();					// ޮè
#endif
				}
				Host_ack_in_received(); Host_send_in();
			}
			if(hid_enter_dfu==TRUE)
			{
				LOG_STR_CODE(log_enter_boot);
#if( HID_GENERIC_DEMO_FULL == ENABLE )
				buf_hid[3]=0x55;
				buf_hid[4]=0xAA;
				host_send_data(PIPE_HID_OUT, 8, buf_hid);
#else
				buf_hid[0]=0x55;
				buf_hid[1]=0xAA;
				buf_hid[2]=0x55;
				buf_hid[3]=0xAA;
				usb_request.bmRequestType = USB_SETUP_SET_CLASS_INTER;
				usb_request.bRequest      = SETUP_HID_SET_REPORT;
				usb_request.wValue        = (REPORT_TYPE_FEATURE<<8);
				usb_request.wIndex        = 0;
				usb_request.wLength       = 4;
				usb_request.uncomplete_read = FALSE;
				host_send_control(buf_hid);
#endif
			}
		}
	}
	// uؒf
	if(Is_device_disconnection_event())
	{
		Leds_off();
		hid_connected=0;
		hid_enter_dfu=0;
	}
}
