/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBν ގxͯ ̧
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _USB_HOST_HUB_H_
#define _USB_HOST_HUB_H_

//_____ ݸٰ ____________________________________________________________

#include "modules/usb/usb_task.h"

//_____ ϸ ________________________________________________________________

//_____ W` ___________________________________________________________

#ifndef HUB_CLASS
  #define HUB_CLASS				0x09
#endif

//  ׽@\I
#define C_HUB_LOCAL_POWER		0
#define C_HUB_OVER_CURRENT		1
#define PORT_CONNECTION			0
#define PORT_ENABLE				1
#define PORT_SUSPEND			2
#define PORT_OVER_CURRENT		3
#define PORT_RESET				4
#define PORT_POWER				8
#define PORT_LOW_SPEED			9
#define C_PORT_CONNECTION		16
#define C_PORT_ENABLE			17
#define C_PORT_SUSPEND			18
#define C_PORT_OVER_CURRENT		19
#define C_PORT_RESET			20
#define PORT_TEST				21
#define PORT_INDICATOR			22

#define NB_PORT_OFFSET			2

#define HUB_DEVICE_POWERED		2
#define HUB_DEVICE_CONNECT		3
#define HUB_DEVICE_WAIT_RST_1	4
#define HUB_DEVICE_WAIT_RST_2	5
#define HUB_DEVICE_READY		6

#define HUB_PORT_CONNECTION		0
#define HUB_PORT_RESET			1
#define HUB_PORT_DISCONNECT		2

#if (USB_HUB_SUPPORT==ENABLE)

extern U8 f_hub_port_disconnect;
extern U8 hub_device_address[USB_MAX_HUB_NUMBER];
extern U8 hub_port_state[USB_MAX_HUB_NUMBER][HUB_MAX_NB_PORT];
extern U8 nb_hub_present;

U32 get_port_status (U8 port_number);
void hub_manage_port_change_status (U8 port_change_status, U8 hub_number);
void enumerate_hub_port_device (U8 hub_port, U8 port_ev, U8 hub_number);
void hub_init (U8 hub_number);

/**
 * Clear_hub_feature
 *
 * @brief ̊֐ދ@\v𑗂܂B
 *
 * @param	U8 feature_selector
 *
 * @return	
 */
#define Clear_hub_feature(feature_selector)	(usb_request.bmRequestType = USB_SETUP_SET_CLASS_DEVICE,\
										 usb_request.bRequest      = SETUP_CLEAR_FEATURE,\
										 usb_request.wValue        = (U16)feature_selector,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * Clear_port_feature
 *
 * @brief ̊֐߰ċ@\v𑗂܂B
 *
 * @param	U8	feature_selector
 * @param	U8	߰
 *
 * @return	
 */
#define Clear_port_feature(feature_selector,port)	(usb_request.bmRequestType = USB_SETUP_SET_CLASS_OTHER,\
										 usb_request.bRequest      = SETUP_CLEAR_FEATURE,\
										 usb_request.wValue        = (U16)feature_selector,\
										 usb_request.wIndex        = port,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * Get_hub_descriptor
 *
 * @brief ̊֐ދLqq擾v𑗂܂B
 *
 * @return	
 */
#define Get_hub_descriptor()			(usb_request.bmRequestType = USB_SETUP_GET_CLASS_DEVICE,\
										 usb_request.bRequest      = SETUP_GET_DESCRIPTOR,\
										 usb_request.wValue        = 0x2900,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0xFF,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * Get_hub_status
 *
 * @brief ̊֐ޏԎ擾v𑗂܂B
 *
 * @return	
 */
#define Get_hub_status()				(usb_request.bmRequestType = USB_SETUP_GET_CLASS_DEVICE,\
										 usb_request.bRequest      = SETUP_GET_STATUS,\
										 usb_request.wValue        = 0,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 4,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * Get_port_status
 *
 * @brief ̊֐߰ďԎ擾v𑗂܂B
 *
 * @param	U8 port
 * @return	
 */
#define Get_port_status(port)			(usb_request.bmRequestType = USB_SETUP_GET_CLASS_OTHER,\
										 usb_request.bRequest      = SETUP_GET_STATUS,\
										 usb_request.wValue        = 0,\
										 usb_request.wIndex        = port,\
										 usb_request.wLength       = 4,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * Set_hub_feature
 *
 * @brief ̊֐ދ@\ݒv𑗂܂B
 *
 * @param	U8 feature_selector
 *
 * @return	
 */
#define Set_hub_feature(feature)		(usb_request.bmRequestType = USB_SETUP_SET_CLASS_DEVICE,\
										 usb_request.bRequest      = SETUP_SET_FEATURE,\
										 usb_request.wValue        = (U16)feature,\
										 usb_request.wIndex        = 0,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

/**
 * Set_port_feature
 *
 * @brief ̊֐߰ċ@\ݒv𑗂܂B
 *
 * @param	U8 feature_selector
 * @param	U8 port
 *
 * @return	
 */
#define Set_port_feature(feature,port)	(usb_request.bmRequestType = USB_SETUP_SET_CLASS_OTHER,\
										 usb_request.bRequest      = SETUP_SET_FEATURE,\
										 usb_request.wValue        = (U16)feature,\
										 usb_request.wIndex        = port,\
										 usb_request.wLength       = 0,\
										 usb_request.uncomplete_read = FALSE,\
										 host_send_control(data_stage))

#define Set_port_indicator_green(i)		Set_port_feature(PORT_INDICATOR,0x0200+i)
#define Set_port_indicator_amber(i)		Set_port_feature(PORT_INDICATOR,0x0100+i)
#define Set_port_indicator_auto(i)		Set_port_feature(PORT_INDICATOR,0x0300+i)
#define Set_port_indicator_off(i)		Set_port_feature(PORT_INDICATOR,0x0000+i)

#define Set_port_reset(i)				Set_port_feature(PORT_RESET,i)
#define Set_port_suspend(i)				Set_port_feature(PORT_SUSPEND,i)
#define Clear_port_suspend(i)			Clear_port_feature(PORT_SUSPEND,i)

#define Set_port_power(i)				Set_port_feature(PORT_POWER,i);
#define Clear_port_power(i)				Clear_port_feature(PORT_POWER,i);

//! @}

//! USB؍\Őڑꂽނ̑uڽi[邽߂̕\
extern U8 hub_device_address[USB_MAX_HUB_NUMBER];

//! USB؍\Őڑꂽސ
extern U8 nb_hub_present;

#endif

#endif // _USB_HOST_HUB_H_
