/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͐ɉUSBKEY̋@\܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#ifndef PROD_TEST
  #define PROD_TEST		DISABLE
#endif

// ̧ т͓ɑ΂ĕKvȂ̂ݸٰނ܂B
#if (PROD_TEST==ENABLE)

  #ifndef __ICCAVR__
	#error PROD_TEST feature run only under IAR
  #endif

  #if TARGET_BOARD != USBKEY
	#error PROD_TEST feature run only under USBKEY
  #endif

#include "modules/file_system/navigation.h"
#include "modules/control_access/ctrl_access.h"
#include "lib_mcu/flash/flash_lib.h"
#include "lib_system\memory\memory.h"
//#include "string.h"

//_____ ϸ ________________________________________________________________

#define TEST_FLAG_ADDR		0x500

//_____ 錾 _______________________________________________________________

// ̔z͌IōXVׯ(=)޲Ă蓖Ă܂B
code char g_prd_test At(TEST_FLAG_ADDR);	// ɂ=n=0x00

static void launch_test (void);

//! ̊֐͕KvȐ𑖍s܂B
//!
void prod_test (void)
{
	if( 0x00 != g_prd_test )
		return;								// ɏI

	launch_test();
	while(1);
}

static void launch_test (void)
{
	volatile U16 u16_tmp;
	U8 flag, save_int;
	char name_first_file[] = "USBKEY.tmp";

	// ̪
	Joy_init();
	Leds_init();
	Hwb_button_init();

	// ޮè
	while( !Is_btn_middle() );
	while( !Is_joy_right() );
	while( !Is_joy_left() );
	while( !Is_joy_up() );
	while( !Is_joy_down() );

	// DataFlash̫ϯ
	nav_reset();
	if( !nav_drive_set( 0 ) )
		return;								// ُ

	// 4ŏ
	memset( fs_g_sector , 0x55 , FS_CACHE_SIZE );
	if (CTRL_GOOD != ram_2_memory( 0 , 16+0 , fs_g_sector ))
		return;								// ُ
	if (CTRL_GOOD != ram_2_memory( 0 , 16+2 , fs_g_sector ))
		return;								// ُ
	memset( fs_g_sector , 0xAA , FS_CACHE_SIZE );
	if (CTRL_GOOD != ram_2_memory( 0 , 16+1 , fs_g_sector ))
		return;								// ُ
	if (CTRL_GOOD != ram_2_memory( 0 , 16+3 , fs_g_sector ))
		return;								// ُ

	// ̒l
	if (CTRL_GOOD != memory_2_ram( 0 , 16+0 , fs_g_sector ))
		return;								// ُ
	for( u16_tmp=0; u16_tmp<FS_CACHE_SIZE; u16_tmp++) {
		if( fs_g_sector[u16_tmp] != 0x55 )
			return;							// ُ
	}
	if (CTRL_GOOD != memory_2_ram( 0 , 16+2 , fs_g_sector ))
		return;								// ُ
	for( u16_tmp=0; u16_tmp<FS_CACHE_SIZE; u16_tmp++) {
		if( fs_g_sector[u16_tmp] != 0x55 )
			return;							// ُ
	}
	if (CTRL_GOOD != memory_2_ram( 0 , 16+1 , fs_g_sector ))
		return;								// ُ
	for( u16_tmp=0; u16_tmp<FS_CACHE_SIZE; u16_tmp++) {
		if( fs_g_sector[u16_tmp] != 0xAA )
			return;							// ُ
	}
	if (CTRL_GOOD != memory_2_ram( 0 , 16+3 , fs_g_sector ))
		return;								// ُ
	for( u16_tmp=0; u16_tmp<FS_CACHE_SIZE; u16_tmp++) {
		if( fs_g_sector[u16_tmp] != 0xAA )
			return;							// ُ
	}

	if( !nav_drive_format( FS_FORMAT_DEFAULT ) )
		return;								// ُ

	// DataFlashňꎞ̧ق쐬
	if( !nav_file_create(name_first_file ))
		return;								// ُ

	// Ԍ׸ލXV
	if( !flash_lib_check() )
		return;								// ُ
	save_int=Get_interrupt_state();
	Disable_interrupt();
	flag = TRUE;
	flash_wr_block( &flag, TEST_FLAG_ADDR, 1 );
	// 荞ݏԕ
	if(save_int) { Enable_interrupt(); }

	// LEDOK\
	while (1)
	{
		// LED_
		Led1_toggle();
		Led2_toggle();
		for( u16_tmp=0; u16_tmp<0xFFFF; u16_tmp++ );
	}
}

#endif // (PROD_TEST==ENABLE)
